<%@ Language=VBScript %>
<%
'*************************************************************************
' DO NOT MODIFY THIS SCRIPT IF YOU WANT UPDATES TO WORK!
' Function : Get shipping info, payment info
' Product  : Shopping Tree Store Frontend
' Version  : 3.3
' Modified : January 2005
' Copyright: Copyright (C) 2004 Shopping Tree.Com 
'            See "license.txt" for this product for details regarding 
'            licensing, usage, disclaimers, distribution and general 
'            copyright requirements. If you don't have a copy of this 
'            file, you may request one at webmaster@ShoppingTree.com
'*************************************************************************
' 05/31/06	Corrected shipping array error.
' 07/20/06  Add PayPalPro to payment types
'*************************************************************************
Option explicit
Response.Buffer = true
%>
<!--#include file="_INCconfig_.asp"-->
<!--#include file="_INCappDBConn_.asp"-->
<!--#include file="_INCappFunctions_.asp"-->
<!--#include file="_INCrc4_.asp"-->
<!--#include file="_INCshipFunctions_.asp"-->
<%
'Work fields
dim i, f				'Indexes
dim pCCTypeArr			'Array of Valid Credit Card Types
dim arrayErrors			'Array of errors on the form (if any)
dim shipDetails
dim shipError
dim paymentRequired
dim formID

'Customer
dim locState
dim locCountry
dim zip
dim city
dim shippingLocState
dim shippingLocCountry
dim shippingZip
dim shippingCity
dim addrtype

'cartHead
dim subTotal
dim taxTotal
dim shipmentTotal
dim handlingFeeTotal
dim otherFeeTotal
dim Total
dim shipmentMethod
dim paymentType
dim cardType
dim cardNumber
dim cardExpMonth
dim cardExpYear
dim cardName
dim cardVerify
dim generalComments

'shipRates
dim locShipZone

'Database
dim mySQL
dim conntemp
dim rstemp
dim rstemp2


'Session
dim idOrder
dim idCust

'*************************************************************************

'Open Database Connection
call openDb()

'Store Configuration
if loadConfig() = false then
	call errorDB(LangText("ErrConfig",""),"")
end if

'Get/Set Cart/Order Session
idOrder = sessionCart()

'Get/Set Customer Session
idCust  = sessionCust()

'Check if the session is still active
if isNull(idOrder) then
	response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrCartEmpty",""))
end if

'Check if cart has any items
if cartQty(idOrder) = 0 then
	response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrCartEmpty",""))
end if

'Check if minimum order amount has been met
if cartTotal(idOrder,0) < pMinCartAmount then
	response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrMinPrice",""))
%>
	<%=moneyS(Exchange(pMinCartAmount))%>
<%
end if

'Double-check that the Customer is logged on
if isNull(idCust) then
	response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrNotLoggedIn",""))
end if

'Get Form ID
formID = trim(Request.Form("formID"))

'Before we display the form for the first time, do some checks
if formID = "" then

	'Retrieve all available fields from DB
	mySQL="SELECT a.shipmentMethod,a.shipmentTotal,a.cardType," _
		& "       a.cardNumber,a.cardExpMonth,a.cardExpYear,a.cardName," _
		& "       a.cardVerify,a.generalComments,b.paymentType " _
	    & "FROM   cartHead a, customer b " _
	    & "WHERE  a.idOrder = " & validSQL(idOrder,"I") & " " _
	    & "AND    b.idCust  = " & validSQL(idCust,"I")  & " "
	set rsTemp = openRSexecute(mySQL)
	if not rstemp.eof then
		shipmentMethod  = trim(rstemp("shipmentMethod")&"")
		shipmentTotal   = trim(rstemp("shipmentTotal")&"")
		shipDetails     = shipmentTotal & "|" & shipmentMethod
		paymentType     = trim(rstemp("paymentType")&"")
		cardType		= trim(rstemp("cardType")&"")
		cardNumber		= trim(EnDeCrypt(Hex2Ascii(rstemp("cardNumber")),rc4Key)&"")
		cardExpMonth	= trim(rstemp("cardExpMonth")&"")
		cardExpYear		= trim(rstemp("cardExpYear")&"")
		cardName		= trim(rstemp("cardName")&"")
		cardVerify		= trim(rstemp("cardVerify")&"")
		generalComments	= trim(rstemp("generalComments")&"")
	else
		'No cartHead Record on DB (which is highly unlikely because
		'cartHead record has already been tested in sessionCart()
		'at the beginning of this script).
		response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrInvOrder",""))
	end if
	call closeRS(rsTemp)
	
end if
	
'Check if the Customer clicked the "Next" button
if formID = "02" then

	'Get values from the calling form
	shipDetails = validHTML(request.form("shipDetails"))
	if inStr(shipDetails,"|") > 0 then
		shipmentTotal  = mid(shipDetails,1,instr(shipDetails,"|")-1)
		shipmentMethod = mid(shipDetails,instr(shipDetails,"|")+1)
	else
		shipmentTotal  = ""
		shipmentMethod = ""
	end if
	handlingFeeTotal = validHTML(request.form("handlingFeeTotal"))
	paymentRequired  = validHTML(request.form("paymentRequired"))
	paymentType		 = validHTML(request.form("paymentType"))
	cardType		 = validHTML(request.form("cardType"))
	cardNumber		 = validHTML(request.form("cardNumber"))
	cardExpMonth	 = validHTML(request.form("cardExpMonth"))
	cardExpYear		 = validHTML(request.form("cardExpYear"))
	cardName		 = validHTML(request.form("cardName"))
	cardVerify		 = validHTML(request.form("cardVerify"))
	generalComments	 = validHTML(request.form("generalComments"))
	
	'Validate Shipping
	if len(shipmentTotal) = 0 or not isNumeric(shipmentTotal) then
		arrayErrors = arrayErrors & "|shipDetails"
	end if
	if len(shipmentMethod) = 0 then
		arrayErrors = arrayErrors & "|shipDetails"
	end if
	
	'Validate Handling Fee
	if len(handlingFeeTotal) = 0 or not isNumeric(handlingFeeTotal) then
		arrayErrors = arrayErrors & "|handlingFeeTotal"
	end if

	'Validate Credit Card Info (if Required for this Order)
	if lCase(paymentType) = "creditcard" and paymentRequired = "Y" then
		'Card Type
		if len(cardType) = 0 then
			arrayErrors = arrayErrors & "|cardType"
		end if
		'Card Number
		if not isCreditCard(cardNumber) then
			arrayErrors = arrayErrors & "|cardNumber"
		end if
		'Card Month
		if isEmpty(cardExpMonth) or not isNumeric(cardExpMonth) then
			arrayErrors = arrayErrors & "|cardExpMonth"
		end if
		'Card Year
		if isEmpty(cardExpYear)or not isNumeric(cardExpYear) then
			arrayErrors = arrayErrors & "|cardExpYear"
		end if
		'Card Month + Year not expired
		if not isDate(cardExpMonth & "/01/" & cardExpYear) then
			arrayErrors = arrayErrors & "|cardExpMonth"
			arrayErrors = arrayErrors & "|cardExpYear"
		else
			if date() > CDate(cardExpMonth & "/01/" & cardExpYear) then
				arrayErrors = arrayErrors & "|cardExpMonth"
				arrayErrors = arrayErrors & "|cardExpYear"
			end if
		end if
		'Card Name
		if len(cardName) = 0 then
			arrayErrors = arrayErrors & "|cardName"
		end if
	end if
	
	'Validate Comments
	if len(generalComments) > 250 then
		arrayErrors = arrayErrors & "|generalComments"
	end if
	
	'There were no errors
	if len(trim(arrayErrors)) = 0 then
	
		'Update Shopping Cart on DB
		mySQL = "UPDATE cartHead SET " _
			&   "shipmentMethod	  = '" & validSQL(shipmentMethod,"A") & "', " _
			&   "shipmentTotal	  = "  & validSQL(shipmentTotal,"D") & ", " _
			&   "handlingFeeTotal = "  & validSQL(handlingFeeTotal,"D") & ", " _
			&   "otherFeeTotal	  = "  & validSQL(getPaymentFee(paymentType),"D") & ", " _
			&   "paymentType	  = '" & validSQL(paymentType,"A") & "', " _
			&   "cardType		  = '" & validSQL(cardType,"A") & "', " _
			&   "cardNumber		  = '" & validSQL(Ascii2Hex(EnDeCrypt(cardNumber,rc4Key)),"A") & "', " _
			&   "cardExpMonth	  = '" & validSQL(cardExpMonth,"A") & "', " _
			&   "cardExpYear	  = '" & validSQL(cardExpYear,"A") & "', " _
			&   "cardName		  = '" & validSQL(cardName,"A") & "', " _
			&   "cardVerify		  = '" & validSQL(cardVerify,"A") & "', " _
			&   "generalComments  = '" & validSQL(generalComments,"A") & "' " _
			&   "WHERE idOrder	  =  " & validSQL(idOrder,"I")
		set rsTemp = openRSexecute(mySQL)
		call closeRS(rsTemp)
		
		'Onto next page
		Response.Redirect "40_SubmitOrder.asp"
	
	end if
	
end if

'If we get this far, it's either because this script was called by 
'another script, or the script called itself but failed some checks.

'------------------------
' START - SHIPPING RATES 
'------------------------

'Determine Shipping Destination
mySQL = "SELECT locState,locCountry,city,zip," _
      & "       shippingLocState,shippingLocCountry," _
      & "       shippingCity,shippingZip,addrtype,shippingaddrtype " _
	  & "FROM   customer " _
	  & "WHERE  idCust = " & validSQL(idCust,"I")
set rsTemp = openRSexecute(mySQL)
if not rsTemp.eof then
	locCountry			= trim(rsTemp("locCountry")&"")
	locState			= trim(rsTemp("locState")&"")
	city				= trim(rsTemp("city")&"")
	zip					= trim(rsTemp("zip")&"")
	shippingLocCountry	= trim(rsTemp("shippingLocCountry")&"")
	shippingLocState	= trim(rsTemp("shippingLocState")&"")
	shippingCity		= trim(rsTemp("shippingCity")&"")
	shippingZip			= trim(rsTemp("shippingZip")&"")
	addrtype			= trim(rsTemp("addrType")&"")
	shippingaddrType    = trim(rsTemp("shippingaddrtype")&"")
	if len(shippingLocCountry & shippingLocState) = 0 then
		shippingLocCountry	= locCountry
		shippingLocState	= locState
		shippingCity		= City
		shippingZip			= zip
		shippingaddrtype    = addrtype
	end if
else
	response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrShipLoc",""))
end if
call closeRS(rsTemp)

'Determine Shipping Zone
locShipZone = getShipZone(shippingLocCountry,shippingLocState,shippingCity,shippingZip)
if locShipZone = null then
	response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrShipZone",""))
end if

'Determine Totals to be used when calculating shipping rates
call calcShipTotals(idOrder)

'Free Shipping if no items were found that requires shipping.
if totalShipItems = 0 then 
	shipArray(0,0) = 0.00
	shipArray(0,1) = LangText("GenNoShipCharge","")
	
'Calculate shipping rates
else

	'Initialize shipping error session variable
	session(storeID & "shipError") = ""
	
	'Calculate Store Rates
	call calcStoreRates(totalShipPrice,totalShipWeight,locShipZone)
	
	'Check for free shipping (A rate of zero)
	for f = 0 to ubound(shipArray) - 1
		if len(shipArray(f,1)) <> "" then
			exit for
		else
			if shipArray(f,0) <> 0.00 then
				redim shipArray(100,2)
				shipArray(0,0) = 0.00
				shipArray(0,1) = LangText("GenNoShipCharge","")
				exit for
			end if
		end if
	next

	'Calculate Realtime Rates
	call calcOnlineRates(totalShipWeight,shippingLocCountry,shippingLocState,shippingZip)
	
	'Move error (if any) to local variable for later evaluation
	if session(storeID & "shipError") <> "" then
		shipError = session(storeID & "shipError")
	end if
	session(storeID & "shipError") = null
	
end if

'Execute Custom shipping rates user exit %>
<!--#include file="../UserMods/_INCship_.asp"--> 

<%

'Check shipping rate array
if not(validShipArray()) then
	if shipError = "" then
		response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrNoShipRate","") & " (P" & totalShipPrice & " W" & totalShipWeight & " Z" & locShipZone & ")")
	else
		response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(shipError         & " (P" & totalShipPrice & " W" & totalShipWeight & " Z" & locShipZone & ")")
	end if
end if

'For debug purposes, write shipping data as hidden HTML
Response.Write vbCrlf & "<!-- P[" & totalShipPrice & "] W[" & totalShipWeight & "] I[" & totalShipItems & "] Z[" & locShipZone & "] -->" & vbCrlf

'------------------------
' END - SHIPPING RATES 
'------------------------

'Check if Payment is required for this Order
if (cartTotal(idOrder,0) + shipArray(0,0)) > 0 then
	paymentRequired = "Y"
else
	paymentRequired = "N"
end if

'Determine Handling Fee
if totalShipWeight > 0 then
	handlingFeeTotal = handlingFeeAmt
else
	handlingFeeTotal = 0.00
end if

%>
<!--#include file="../UserMods/_INCtemplate_.asp"-->
<%

'Close Database Connection
call closedb()

'*************************************************************************
'Main Shopping Cart Display Area
'*************************************************************************
sub cartMain()

'If there were errors, show message
if len(trim(arrayErrors)) > 0 then
	arrayErrors = split(LCase(arrayErrors),"|")
	Response.Write "<font color=red><i>" & LangText("ErrInvForm","") & "</i></font><br><br>"
else
	arrayErrors = array("")
end if
%>

<!-- Outer Table Cell -->
<table border="0" cellpadding="0" cellspacing="0" width=350><tr><td>

<!-- Inner Table -->
<table border="0" cellspacing="0" cellpadding="2" width="100%">

	<form METHOD="POST" name="shippingform" action="30_Ship_CC.asp">
	<input type=hidden name=formID          value="02">
	<input type=hidden name=paymentRequired value="<%=paymentRequired%>">
	<input type=hidden name=paymentType     value="<%=paymentType%>">
	<tr>
		<td colspan=2 valign=middle class="CPpageHead">
			<table border=0 cellpadding=0 cellspacing=0 width="100%">
			<tr>
				<td nowrap align=left>
					<b><%=LangText("GenMetShip","")%></b> <%=checkFieldError("shipDetails",arrayErrors)%>
				</td>
				<td nowrap align=right>
					<b><font color=#800000><%=LangText("GenStep2","")%></font></b>
				</td>
			</tr>
			</table>
		</td>
	</tr>
    <TR><TD colspan=2><img src="../UserMods       	/misc_cleardot.gif" height=4 width=1><br></TD></TR>
	<TR>
		<td nowrap colspan=2>
			<input type="hidden" name="handlingFeeTotal" value="<%=handlingFeeTotal%>">
			<%=LangText("GenHandlingFeeMsg","")%> : <b><%=moneyS(Exchange(handlingFeeTotal))%></b> 
			<%=checkFieldError("handlingFeeTotal",arrayErrors)%><br><br>
		</td>
	</TR>
	<TR>
		<td nowrap colspan=2>
<%
			'If only one shipping rate, auto-select it
			if len(trim(shipArray(1,0)&"")) = 0 then
				shipDetails = shipArray(0,0) & "|" & shipArray(0,1)
			end if

			'Display shipping rates
			if shipDisplayType = "0" then %>
				<select name=shipDetails size=1>
<%			end if
			for f = 0 to Ubound(shipArray) 
				if len(trim(shipArray(f,0))) > 0 then
					if shipDisplayType = "0" then %>
						<option <%=checkMatch(shipDetails,shipArray(f,0) & "|" & shipArray(f,1))%> value="<%=shipArray(f,0) & "|" & shipArray(f,1)%>"><%=shipArray(f,1) & " &nbsp;"%> <%=moneyS(Exchange(shipArray(f,0)))%>
<%					else %>
						<input type="radio" name="shipDetails" <%=replace(checkMatch(shipDetails,shipArray(f,0) & "|" & shipArray(f,1)),"selected","checked")%> value="<%=shipArray(f,0) & "|" & shipArray(f,1)%>"><%=shipArray(f,1)%>&nbsp;&nbsp;<b><%=moneyS(Exchange(shipArray(f,0)))%></b><br>
<%					end if
				end if
			next
			if shipDisplayType = "0" then %>
				</select>
<%			end if %>
		</td>
	</TR>
	
<%	'Offline Credit Cards
	if lCase(paymentType) = "creditcard" and paymentRequired = "Y" then
%>
		<TR><TD COLSPAN="2">&nbsp;</TD></TR>
		<TR>
			<td colspan=2 valign=middle class="CPpageHead">
				<b><%=LangText("GenPayDetail","")%></b>
			</td>
		</TR>
		<TR><TD colspan=2><img src="../UserMods/misc_cleardot.gif" height=4 width=1><br></TD></TR>
<%
		'If demo mode, fill in the card number
		if demoMode = "Y" and len(cardNumber) = 0 then
			cardNumber   = "4111 1111 1111 1111"
		end if
%>
		<TR> 
			<td nowrap><%=LangText("GenCCtype","") & " " & checkFieldError("cardType",arrayErrors)%></td>
			<td>
				<select name="cardType" size=1>
					<option value="">
<%					pCCTypeArr = split(pCCType,",")
					for f = 0 to Ubound(pCCTypeArr) 
						if len(trim(pCCTypeArr(f))) > 0 then %>
						<option <%=checkMatch(cardType,pCCTypeArr(f))%> value="<%=pCCTypeArr(f)%>"><%=pCCTypeArr(f)%></option>
<%						end if
					next %>
				</select>
			</td>
		</TR>
		<TR> 
			<TD nowrap><%=LangText("GenCCnumber","") & " " & checkFieldError("cardNumber",arrayErrors)%></TD>
			<TD><input type=text name=cardNumber size=20 maxlength="20" value="<%=cardnumber%>"></TD>
		</TR>
		<TR> 
			<TD nowrap><%=LangText("GenCCexpire","") & " " & checkFieldError("CardExpMonth",arrayErrors) & checkFieldError("CardExpYear",arrayErrors)%></TD>
			<TD>
				<select name="CardExpMonth">
					<option value=""><%=LangText("GenMonth","")%></option>
<%					for I = 1 to 12 %>
						<option <%=checkMatch(CardExpMonth,CStr(I))%> value="<%=I%>"><%=I%></option>
<%					next %>
				</select>
				&nbsp;/&nbsp;
				<select name="CardExpYear">
					<option value=""><%=LangText("GenYear","")%></option>
<%					for I = year(now()) to year(now()) + 10 %>
						<option <%=checkMatch(CardExpYear,CStr(I))%> value="<%=I%>"><%=I%></option>
<%					next %>
				</select>
			</TD>
		</TR>
		<TR> 
			<TD nowrap><%=LangText("GenCCcvv","") & " " & checkFieldError("cardVerify",arrayErrors)%></TD>
			<TD><input type=text name=cardVerify size=4 maxlength="4" value="<%=cardVerify%>"></TD>
		</TR>
		<TR> 
			<TD nowrap><%=LangText("GenCCname","") & " " & checkFieldError("cardName",arrayErrors)%></TD>
			<TD><input type=text name=cardName size=25 maxlength="100" value="<%=cardName%>"></TD>
		</TR>
<%
	end if
%>
	<TR><TD COLSPAN="2">&nbsp;</TD></TR>
	<TR>
		<td colspan=2 valign=middle class="CPpageHead">
			<b><%=LangText("GenAddComment","")%></b> <%=LangText("GenCommentsHelp","") & " " & checkFieldError("generalComments",arrayErrors)%>
		</td>
	</TR>
	<TR><TD colspan=2><img src="../UserMods/misc_cleardot.gif" height=4 width=1><br></TD></TR>
    <TR>
		<TD colspan=2><textarea name="generalComments" rows=3 cols="35" wrap="soft"><%=generalComments%></textarea></TD>
    </TR>
	<TR><TD colspan=2>&nbsp;</TD></TR>
    <TR><TD colspan=2><input type="submit" name="Submit" value="<%=LangText("GenNextBut","")%>"></TD></TR>
	<TR><TD colspan=2>&nbsp;</TD></TR>
	
<%	'Show UPS Trademark Notice if required
	if len(trim(session(storeID & "UPSnotice")&"")) > 0 then %>
		<TR>
			<TD colspan="2"><br><%=session(storeID & "UPSnotice")%></TD>
		</TR>
<%	end if %>

	</form>
	
</table>

<!-- End Outer Table Cell -->
</td></tr></table>
<br>
<%
end sub

'*************************************************************************
'Check Credit Card Number (Test Number - 4111111111111111)
'*************************************************************************
function isCreditCard(cardNo)
	dim lCard, lC, cStat, temp, tempChar, i, d
	cardNo = trim(cardNo)
	cardNo = replace(cardNo," ","")
	cardNo = replace(cardNo,"-","")
	if isNumeric(cardNo) then 
		isCreditCard	= false 
		lCard			= len(cardNo) 
		lC				= right(cardNo,1) 
		cStat			= 0 
		for i=(lCard-1) to 1 step -1 
		    tempChar = mid(cardNo,i,1) 
		    d		 = CLng(tempChar) 
		    if lcard mod 2 = 1 then 
		        temp = d*(1+((i+1) mod 2)) 
		    else 
		        temp = d*(1+(i mod 2)) 
		    end if 
		    if temp < 10 then 
		        cStat = cStat + temp  
		    else 
		        cStat = cStat + temp - 9 
		    end if 
		next
		cStat = (10-(cStat mod 10)) mod 10 
		if CLng(lC) = cStat then 
			isCreditCard = true
		end if
	end if
end function

'*************************************************************************
'Get Payment fee for a particular Payment Method
'*************************************************************************
function getPaymentFee(paymentType)
	select case lCase(paymentType)
		case "mailin"
			getPaymentFee = feeMailIn
		case "callin"
			getPaymentFee = feeCallIn
		case "faxin"
			getPaymentFee = feeFaxIn
		case "cod"
			getPaymentFee = feeCOD
		case "creditcard"
			getPaymentFee = feeOffCC
		case "50_paypal"
			getPaymentFee = feePayPal
		case "50_2checkout"
			getPaymentFee = fee2CO
		case "50_authorizenet"
			getPaymentFee = feeAuthNet
		case "50_paypalpro"
			getPaymentFee = feePayPalPro
		case "custom"
			getPaymentFee = feeCustom
		case else
			getPaymentFee = 0
	end select
end function
%>